searchData={"items":[{"type":"module","title":"SSHKeyEx","doc":"Documentation for `SSHKeyEx`.","ref":"SSHKeyEx.html"},{"type":"module","title":"SSHKeyEx.Native","doc":"Documentation for `SSHKeyEx.Native`.","ref":"SSHKeyEx.Native.html"},{"type":"function","title":"SSHKeyEx.Native.priv_from_openssh/1","doc":"","ref":"SSHKeyEx.Native.html#priv_from_openssh/1"},{"type":"function","title":"SSHKeyEx.Native.pub_from_openssh/1","doc":"","ref":"SSHKeyEx.Native.html#pub_from_openssh/1"},{"type":"type","title":"SSHKeyEx.Native.t/0","doc":"","ref":"SSHKeyEx.Native.html#t:t/0"},{"type":"module","title":"SSHKeyEx.PrivateKey","doc":"Documentation for `SSHKeyEx.PrivateKey`.","ref":"SSHKeyEx.PrivateKey.html"},{"type":"function","title":"SSHKeyEx.PrivateKey.from_openssh/1","doc":"Parses an OpenSSH format private key and returns a PrivateKey struct.\n\nThe key must be in the standard OpenSSH format, starting with \"-----BEGIN OPENSSH PRIVATE KEY-----\"\nand ending with \"-----END OPENSSH PRIVATE KEY-----\".","ref":"SSHKeyEx.PrivateKey.html#from_openssh/1"},{"type":"function","title":"Parameters - SSHKeyEx.PrivateKey.from_openssh/1","doc":"* `key` - Binary string containing the OpenSSH formatted private key","ref":"SSHKeyEx.PrivateKey.html#from_openssh/1-parameters"},{"type":"function","title":"Returns - SSHKeyEx.PrivateKey.from_openssh/1","doc":"* `{:ok, private_key}` - Successfully parsed key as PrivateKey struct\n  * `{:error, reason}` - If the key is invalid or cannot be parsed","ref":"SSHKeyEx.PrivateKey.html#from_openssh/1-returns"},{"type":"function","title":"Examples - SSHKeyEx.PrivateKey.from_openssh/1","doc":"iex> key = \"\"\"\n    ...> -----BEGIN OPENSSH PRIVATE KEY-----\n    ...> b3BlbnNzaC1rZXktdjEAAAAABG5vbmUAAAAEbm9uZQAAAAAAAAABAAAAMwAAAAtzc2gtZW\n    ...> QyNTUxOQAAACBaNssLYZcsr4VYHx6QhuNWdXV5AkeflMyZkagoRL4k3gAAAJgzrB/7M6wf\n    ...> +wAAAAtzc2gtZWQyNTUxOQAAACBaNssLYZcsr4VYHx6QhuNWdXV5AkeflMyZkagoRL4k3g\n    ...> AAAECJgH6e6W8QVn3XzXJsrgu3mz0nlIJHHJzzBOKscDulYFo2ywthlyyvhVgfHpCG41Z1\n    ...> dXkCR5+UzJmRqChEviTeAAAADmN1cEBzYXVjZXIuY29tAQIDBAUGBw==\n    ...> -----END OPENSSH PRIVATE KEY-----\n    ...> \"\"\"\n    iex> SSHKeyEx.PrivateKey.from_openssh(key)\n    {:ok, %SSHKeyEx.PrivateKey{algorithm: \"ssh-ed25519\", comment: \"cup@saucer.com\", encrypted: false}}","ref":"SSHKeyEx.PrivateKey.html#from_openssh/1-examples"},{"type":"type","title":"SSHKeyEx.PrivateKey.t/0","doc":"","ref":"SSHKeyEx.PrivateKey.html#t:t/0"},{"type":"module","title":"SSHKeyEx.PublicKey","doc":"Documentation for `SSHKeyEx.PublicKey`.","ref":"SSHKeyEx.PublicKey.html"},{"type":"function","title":"SSHKeyEx.PublicKey.from_openssh/1","doc":"Parses an OpenSSH format public key string into a PublicKey struct.\n\nThe function expects a string in the standard OpenSSH public key format:\n`     \\n`","ref":"SSHKeyEx.PublicKey.html#from_openssh/1"},{"type":"function","title":"Parameters - SSHKeyEx.PublicKey.from_openssh/1","doc":"* `key` - A string containing the OpenSSH format public key","ref":"SSHKeyEx.PublicKey.html#from_openssh/1-parameters"},{"type":"function","title":"Returns - SSHKeyEx.PublicKey.from_openssh/1","doc":"* `{:ok, %PublicKey{}}` - Successfully parsed public key with algorithm and comment\n  * `{:error, term()}` - If the key format is invalid or parsing fails","ref":"SSHKeyEx.PublicKey.html#from_openssh/1-returns"},{"type":"function","title":"Examples - SSHKeyEx.PublicKey.from_openssh/1","doc":"iex> SSHKeyEx.PublicKey.from_openssh(\"ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIFo2ywthlyyvhVgfHpCG41Z1dXkCR5+UzJmRqChEviTe cup@saucer.com\\n\")\n    {:ok, %SSHKeyEx.PublicKey{algorithm: \"ssh-ed25519\", comment: \"cup@saucer.com\"}}","ref":"SSHKeyEx.PublicKey.html#from_openssh/1-examples"},{"type":"type","title":"SSHKeyEx.PublicKey.t/0","doc":"","ref":"SSHKeyEx.PublicKey.html#t:t/0"},{"type":"extras","title":"SshKeyEx","doc":"# SshKeyEx [![CI](https://github.com/dennym/ssh_key_ex/actions/workflows/elixir.yml/badge.svg)](https://github.com/dennym/ssh_key_ex/actions/workflows/elixir.yml) [![Hex Version](https://img.shields.io/hexpm/v/ssh_key_ex.svg)](https://hex.pm/packages/ssh_key_ex) [![Hex Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/ssh_key_ex/)\n\nSSHKeyEx is a library for working with SSH keys in Elixir through rust `ssh_key` as nif implementations. Currently it only implements parts of the `PublicKey.from_openssh` functionality to parse out the comment and the used algorithm of the given binary.","ref":"readme.html"},{"type":"extras","title":"Installation - SshKeyEx","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `ssh_key_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ssh_key_ex, \"~> 0.6.1\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}